% data = ask_isolate_class(data)
function option = ask_isolate_class(data)

no_classes = length(data.class_labels);

while 1
    fprintf('These are the classes:\n');
    for i = 1:length(data.class_labels)
        fprintf('%2d - %s\n', i, data.class_labels{i});
    end;

    option = input(sprintf('Which class to you want to isolate (1 to %d) (*0 - cancel*)? ', no_classes));
    option = floor(option);
    
    if option == 0
        break;
    elseif option < 1 || option > no_classes
        disp('Invalid option!');
    else
        break;
    end;
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
