%
%  New biomarker analysis result
%
function o  = bmresult_intersect(o, no_markers)


% These variables in the future can be part of some global setup
MOUNTAIN_WIDTH = 3.26;
HEIGHT_AT = .5;
s = -MOUNTAIN_WIDTH^2/log(HEIGHT_AT);


no_lines = length(o.lines);

for i = 1:length(o.lines)
    o.lines(i) = bmresultline_detect_peaks(o.lines(i), no_markers);
end;


% bm1 and bm2 or 
% bm1 and bm3 or 
% bm2 and bm3 or 
% bm1 and bm2 and bm3

operandss = {[1, 2, 3], [1, 2], [1, 3], [2, 3]};
for i = 1:length(operandss)
    operandss_positions_gone{i} = {};
end;
nf = length(o.x);

no_markers = 0;


% % % % % % % % % % % % % % % % % % % % % % % % %     operands = operandss{i};
% % % % % % % % % % % % % % % % % % % % % % % % %     noop = length(operands);
% % % % % % % % % % % % % % % % % % % % % % % % % positions = zeros(1, no_lines); % per-operator peak position pointers
% % % % % % % % % % % % % % % % % % % % % % % % % maxima = positions; % per-operator perk position maxima
% % % % % % % % % % % % % % % % % % % % % % % % % for j = 1:no_lines
% % % % % % % % % % % % % % % % % % % % % % % % % 	maxima(j) = length(o.lines(j).peak_idxs);
% % % % % % % % % % % % % % % % % % % % % % % % % 	positions(j) = min(1, maxima(j)); % 1 if has peaks, 0 otherwise
% % % % % % % % % % % % % % % % % % % % % % % % % end;
% % % % % % % % % % % % % % % % % % % % % % % % %     
% % % % % % % % % % % % % % % % % % % % % % % % %     
% % % % % % % % % % % % % % % % % % % % % % % % % while 1 % this loop will end when all pointers in 'positions' have reached their maximum
% % % % % % % % % % % % % % % % % % % % % % % % %     for i = 1:length(operandss)
% % % % % % % % % % % % % % % % % % % % % % % % %         operands = operandss{i};
% % % % % % % % % % % % % % % % % % % % % % % % %         
% % % % % % % % % % % % % % % % % % % % % % % % %         % Checks if the same peaks are about to be checked again. For instance, if operands = [3, 4], positions
% % % % % % % % % % % % % % % % % % % % % % % % %         % [1, 1, 1, 1], [2, 1, 1, 1], [1290, 1, 1, 239184] are redundant.
% % % % % % % % % % % % % % % % % % % % % % % % %         % The solution is not very elegant, but I doubt there is the need for something better.
% % % % % % % % % % % % % % % % % % % % % % % % %         flag_already = 0;
% % % % % % % % % % % % % % % % % % % % % % % % %         for j = 1:length(operandss_positions_gone{i})
% % % % % % % % % % % % % % % % % % % % % % % % %             if operandss_positions_gone{i}{j} == positions(operands);
% % % % % % % % % % % % % % % % % % % % % % % % %                 flag_already = 1;
% % % % % % % % % % % % % % % % % % % % % % % % %                 break;
% % % % % % % % % % % % % % % % % % % % % % % % %             end;
% % % % % % % % % % % % % % % % % % % % % % % % %         end;
% % % % % % % % % % % % % % % % % % % % % % % % %         if flag_already
% % % % % % % % % % % % % % % % % % % % % % % % %             continue;
% % % % % % % % % % % % % % % % % % % % % % % % %         end;
% % % % % % % % % % % % % % % % % % % % % % % % %         operandss_positions_gone{i}{end+1} = positions(operands);
% % % % % % % % % % % % % % % % % % % % % % % % %             
% % % % % % % % % % % % % % % % % % % % % % % % %         
% % % % % % % % % % % % % % % % % % % % % % % % %         noop = length(operands);
% % % % % % % % % % % % % % % % % % % % % % % % %     
% % % % % % % % % % % % % % % % % % % % % % % % %         % mountain intersection
% % % % % % % % % % % % % % % % % % % % % % % % %         mountains = ones(1, nf);
% % % % % % % % % % % % % % % % % % % % % % % % %         mountains_max = zeros(1, nf);
% % % % % % % % % % % % % % % % % % % % % % % % %         flag_any = 0;
% % % % % % % % % % % % % % % % % % % % % % % % %         xs = [];
% % % % % % % % % % % % % % % % % % % % % % % % %         ys = [];
% % % % % % % % % % % % % % % % % % % % % % % % %         for j = 1:noop
% % % % % % % % % % % % % % % % % % % % % % % % %             if maxima(operands(j)) == 0
% % % % % % % % % % % % % % % % % % % % % % % % %                 yy = zeros(1, nf);
% % % % % % % % % % % % % % % % % % % % % % % % %             else %positions(j) > 0
% % % % % % % % % % % % % % % % % % % % % % % % %                 flag_any = 1;
% % % % % % % % % % % % % % % % % % % % % % % % %                 peak_idx = o.lines(operands(j)).peak_idxs(positions(operands(j)));
% % % % % % % % % % % % % % % % % % % % % % % % %                 xs(end+1) = o.x(peak_idx);
% % % % % % % % % % % % % % % % % % % % % % % % %                 ys(end+1) = o.lines(operands(j)).y(peak_idx);
% % % % % % % % % % % % % % % % % % % % % % % % %                 yy = exp(-((1:nf)-peak_idx).^2/s);
% % % % % % % % % % % % % % % % % % % % % % % % %             end;
% % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % %             mountains = min(mountains, yy);
% % % % % % % % % % % % % % % % % % % % % % % % %             mountains_max = max(mountains_max, yy);
% % % % % % % % % % % % % % % % % % % % % % % % %         end;
% % % % % % % % % % % % % % % % % % % % % % % % %         
% % % % % % % % % % % % % % % % % % % % % % % % %         
% % % % % % % % % % % % % % % % % % % % % % % % %         if flag_any
% % % % % % % % % % % % % % % % % % % % % % % % %             flag_got = sum(mountains > .5) > 0;
% % % % % % % % % % % % % % % % % % % % % % % % %             
% % % % % % % % % % % % % % % % % % % % % % % % %             if flag_got
% % % % % % % % % % % % % % % % % % % % % % % % %                 ii = mountains > .1;
% % % % % % % % % % % % % % % % % % % % % % % % %                 [dummy, idxsii] = find(ii);
% % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % %                 ii = mountains_max == 1;
% % % % % % % % % % % % % % % % % % % % % % % % %                 [dummy, idxs1] = find(ii);
% % % % % % % % % % % % % % % % % % % % % % % % %                 
% % % % % % % % % % % % % % % % % % % % % % % % %                 
% % % % % % % % % % % % % % % % % % % % % % % % %                 no_markers = no_markers+1;
% % % % % % % % % % % % % % % % % % % % % % % % %                 markers(no_markers).strength = sum(mountains)/sqrt(pi*s);
% % % % % % % % % % % % % % % % % % % % % % % % %                 markers(no_markers).wns = v_ind2x(o.x, [idxs1(1), mountains*(1:nf)'/sum(mountains), idxs1(end)]);
% % % % % % % % % % % % % % % % % % % % % % % % %                 markers(no_markers).operands = operands;
% % % % % % % % % % % % % % % % % % % % % % % % %                 markers(no_markers).xs = xs;
% % % % % % % % % % % % % % % % % % % % % % % % %                 markers(no_markers).ys = ys;
% % % % % % % % % % % % % % % % % % % % % % % % %             end;
% % % % % % % % % % % % % % % % % % % % % % % % %         end;
% % % % % % % % % % % % % % % % % % % % % % % % %     end;
% % % % % % % % % % % % % % % % % % % % % % % % %                 
% % % % % % % % % % % % % % % % % % % % % % % % %             
% % % % % % % % % % % % % % % % % % % % % % % % %     flag_any = 0; % any increment somewhere
% % % % % % % % % % % % % % % % % % % % % % % % %     for j = no_lines:-1:1
% % % % % % % % % % % % % % % % % % % % % % % % %         if maxima(j) > 0
% % % % % % % % % % % % % % % % % % % % % % % % %             if positions(j) < maxima(j)
% % % % % % % % % % % % % % % % % % % % % % % % %                 flag_any = 1;
% % % % % % % % % % % % % % % % % % % % % % % % %                 positions(j) = positions(j)+1;
% % % % % % % % % % % % % % % % % % % % % % % % %                 break;
% % % % % % % % % % % % % % % % % % % % % % % % %             elseif j > 1
% % % % % % % % % % % % % % % % % % % % % % % % %                 positions(j) = 1;
% % % % % % % % % % % % % % % % % % % % % % % % %             else
% % % % % % % % % % % % % % % % % % % % % % % % %                 break;
% % % % % % % % % % % % % % % % % % % % % % % % %             end;
% % % % % % % % % % % % % % % % % % % % % % % % %         end;
% % % % % % % % % % % % % % % % % % % % % % % % %     end;
% % % % % % % % % % % % % % % % % % % % % % % % %     if ~flag_any
% % % % % % % % % % % % % % % % % % % % % % % % %         break;
% % % % % % % % % % % % % % % % % % % % % % % % %     end;
% % % % % % % % % % % % % % % % % % % % % % % % % end;
% % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % if no_markers == 0
% % % % % % % % % % % % % % % % % % % % % % % % %     o.markers = [];
% % % % % % % % % % % % % % % % % % % % % % % % % else
% % % % % % % % % % % % % % % % % % % % % % % % %     o.markers = markers;
% % % % % % % % % % % % % % % % % % % % % % % % % end;



for i = 1:length(operandss)
    cnt = 0;
    operands = operandss{i};
    noop = length(operands);
    positions = zeros(1, noop); % per-operator peak position pointers
    maxima = positions; % per-operator perk position maxima
    
    for j = 1:noop
        maxima(j) = length(o.lines(operands(j)).peak_idxs);
        positions(j) = min(1, maxima(j)); % 1 if has peaks, 0 otherwise
    end;
    
    
    while 1
        % mountain intersection
        mountains = ones(1, nf);
        mountains_max = zeros(1, nf);
        flag_any = 0;
        xs = [];
        ys = [];
        for j = 1:noop
            if maxima(j) == 0
                yy = zeros(1, nf);
            else %positions(j) > 0
                flag_any = 1;
                peak_idx = o.lines(operands(j)).peak_idxs(positions(j));
                xs(end+1) = o.x(peak_idx);
                ys(end+1) = o.lines(operands(j)).y(peak_idx);
                yy = exp(-((1:nf)-peak_idx).^2/s);
            end;

            mountains = min(mountains, yy);
            mountains_max = max(mountains_max, yy);
        end;
        
        
        if flag_any
            flag_got = sum(mountains > .5) > 0;
            
            if flag_got
                ii = mountains > .1;
                [dummy, idxsii] = find(ii);

                ii = mountains_max == 1;
                [dummy, idxs1] = find(ii);
                
                
                no_markers = no_markers+1;
                markers(no_markers).strength = sum(mountains)/sqrt(pi*s);
                markers(no_markers).wns = v_ind2x(o.x, [idxs1(1), mountains*(1:nf)'/sum(mountains), idxs1(end)]);
                markers(no_markers).operands = operands;
                markers(no_markers).xs = xs;
                markers(no_markers).ys = ys;
                
                markers(no_markers).mark = markers(no_markers).strength+length(markers(no_markers).operands)*10;
                
                pp = zeros(1, no_lines);
                for k = 1:noop
                    pp(operands(k)) = positions(k);
                end;
                markers(no_markers).positions2 = pp;
            end;
        end;
                
            
        % position increment
%         flag_exit = 0;
        flag_any = 0; % any increment somewhere
        for j = noop:-1:1
            if maxima(j) > 0
                if positions(j) < maxima(j)
                    flag_any = 1;
                    positions(j) = positions(j)+1;
                    break;
                elseif j > 1
                    positions(j) = 1;
                else
                    break;
                end;
            end;
        end;
%         if ~flag_any
%             flag_exit = 1;
%         end;
        if ~flag_any
            break;
        end;
    end;
            
%     figure;
%         plot(o.x, l.mountains_y);
%         hold on;
%     plot(o.x, result, 'r', 'linewidth',2);
%     keyboard;
    
end;





% Redundancy ellimination
for i = no_markers:-1:1
    for j = i-1:-1:1
        opi = markers(i).operands;
        opj = markers(j).operands;
        if length(opj) > length(opi) && length(intersect(opi, opj)) == length(opi) && ...
           sum(markers(i).positions2(opi) == markers(j).positions2(opi)) == length(opi)
            markers(i) = [];
            break;
        end;
    end;
end;
no_markers = length(markers);


[values, indexes] = sort([markers.mark], 'descend');
markers = markers(indexes);



if no_markers == 0
    o.markers = [];
else
    o.markers = markers;
end;



% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
