% This function is part of BMTOOL, not particularly useful in other contexts.
function results = bmtool_setuplines(results)

MINDIST = 9;

for i_dataset = 1:length(results.items)
    results.items(i_dataset).lines(1).peak_min_distance = MINDIST;
    results.items(i_dataset).lines(1).peak_min_height_perc = .05;
    results.items(i_dataset).lines(1).peak_no_convolutions = 3;
    results.items(i_dataset).lines(1).peak_flag_abs = 1;
    results.items(i_dataset).lines(1).format = '%4.2f';
    results.items(i_dataset).lines(1).flag_zero_line = 1;

    results.items(i_dataset).lines(2).peak_min_distance = MINDIST;
    results.items(i_dataset).lines(2).peak_min_height_perc = .1;
    results.items(i_dataset).lines(2).peak_no_convolutions = 3;
    results.items(i_dataset).lines(2).peak_flag_span = 1;
    results.items(i_dataset).lines(2).format = '%2.0f%%';

    results.items(i_dataset).lines(3).peak_min_distance = MINDIST;
    results.items(i_dataset).lines(3).peak_min_height_perc = .047;
    results.items(i_dataset).lines(3).peak_no_convolutions = 3;
    results.items(i_dataset).lines(3).format = '%3d';
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
