% function codes = data_classes2codes(data)
function codes = data_classes2codes(data)
no_obs = size(data.classes, 1);

codes = cell(1, no_obs);
for i = 1:no_obs
    if data.classes(i) < 0
        codes{i} = mat2str(data.classes(i));
    else
        codes{i} = data.class_labels{data.classes(i)+1};
    end
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
