% title = data_get_feature_names(data, idx_fea)
function s = data_get_title(data)

if strcmp(data.domain, 'original')
    s = 'Data';
elseif strcmp(data.domain, 'pca')
    r = '';
    if data.pca_flag_rotated; r = 'r'; end;
    s = sprintf('%sPCA', r);
elseif strcmp(data.domain, 'lda') 
    s = 'LDA';
elseif strcmp(data.domain, 'pcalda')
    r = '';
    if data.pca_flag_rotated; r = 'r'; end;
    s = sprintf('%sPCA-LDA', r);
else
    s = [data.domain ' figure'];
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
