function data = data_plot_means(data)

pieces = data_split_classes(data);
hs = [];
for i = 1:length(pieces)
    htemp = plot_curve_pieces(data.x, mean(pieces(i).X, 1), 'Color', find_color(i), 'LineWidth', 2);
    hs(end+1) = htemp{1};
    hold on;
end;
legend(hs, data_get_legend(data));
    
if data.flag_wn
    format_wn(data);
end;

title('Class means');
format_frank();
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
