% function d2 = data_transform_lda(data, flag_sphere, flag_modified_s_b, P)
%
% Inputs:
%   data: structure
%   flag_sphere: see fisher_ld()
%   flag_modified_s_b: see calculate_scatters()
%   P:
function d2 = data_transform_lda(data, flag_sphere, flag_modified_s_b, P)

if ~exist('flag_modified_s_b', 'var')
    flag_modified_s_b = 0;
end;

if ~exist('flag_sphere', 'var')
    flag_sphere = 1;
end;

if ~exist('P', 'var')
    P = 0;
end;

% data = data_eliminate_var_0(data, 1e-10); % Is this necessary?
[W_star, lambdas] = fisher_ld(data, flag_sphere, flag_modified_s_b, P);

% % % % % % % % d2 = data;
% % % % % % % % 
% % % % % % % % d2.previous_domain = data.domain;
% % % % % % % % d2.previous_x = data.x;
% % % % % % % % 
% % % % % % % % d2.X = data_normalize(data.X, 'c')*W_star;
% % % % % % % % d2.L = W_star;
% % % % % % % % d2.domain = 'lda';
% % % % % % % % 
% % % % % % % % v = 1:size(W_star, 2);
% % % % % % % % d2.x = v;
% % % % % % % % d2.idx_fea = v;
% % % % % % % % d2.lda_idx_fea = v;
% % % % % % % % 
% % % % % % % % d2.lda_vars = var(d2.X);
% % % % % % % % 


d2 = data;
d2 = data_transform_linear(d2, W_star, 'lda', data_normalize(data.X, 'c'));

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
