% function model = dist_train(model, data)
%
function model = dist_train(model, data)

tic;

% % % % % % % % % % % % 
% % % % % % % % % % % % % Centering is necessary because we are working without biases
% % % % % % % % % % % % X = data_normalize(data.X, 'c');
% % % % % % % % % % % % 
% % % % % % % % % % % % 
% % % % % % % % % % % % TT = model_get_targets(model, data);
% % % % % % % % % % % % model.target_means = mean(TT, 1);
% % % % % % % % % % % % Y = data_normalize(TT, 'c');

model.L = fisher_ld(data, 0, 0, model.penalty)
%inv(X'*X)*X'*Y;

pieces = data_split_classes(data);
nc = length(pieces);
nl = size(model.L, 2);
model.class_means = zeros(nl, nc);
for i = 1:nc
    model.class_means(:, i) = mean(pieces(i).X*model.L, 1)';
end;

model.time_train = toc;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
