% function o = feasel_new()
% 
% Creates a new feature selection object
% 
function o = feasel_new()

o.ds = [];
o.ms = [];
o.flag_forward = 1;

o.idxs = [];

% Both are structure arrays with following fields: .idxs, .performance
o.history = []; % best case for a given number of features
o.cases = []; % all tested cases log

o.min_vars = 0;
o.max_vars = 0;


% validation parameters
o.no_reps = 10;
o.validation_type = 'crossval'; % 'crossval' or 'bootstrap'
o.perc_train = .9; % bootstrap only

% o.logs = [];
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
