function ranking = feasel_get_features_rank(o)

nf = size(o.ds.X, 2);
nf_tested = -1;
no_cases = length(o.cases);


ranking = zeros(1, nf);

for i = 1:no_cases
    if nf == -1
        nf_tested = length(o.cases(i).idxs);
    else
        if length(o.cases(i).idxs) ~= nf
            error('Cannot rank a session where different number of features have been tested!');
        end;
    end;
    
    
    % Could square performances, but for the moment I will just sum them
    ranking(o.cases(i).idxs) = ranking(o.cases(i).performance);
end;
    
    
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
