% function pp = find_peaks(v)
function pp = find_peaks(v)

pp = [];
flag_up = 0;
% flag_down = 0;
for i = 2:length(v)
    dif = v(i)-v(i-1);
    
    
    if dif < 0 && flag_up
        pp(end+1) = floor((i-1+bp)/2); % if there is a plateau, will take the average index.
    end;
    
    if dif ~= 0
        flag_up = dif > 0;
        if flag_up
            bp = i;
        else
            bp = 0;
        end;
    else
    end;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
