function s = format_number_with_commas(n)

frac = n-floor(n);
s = '';
p = floor(n);
i = 1;
while 1
    r = mod(p, 1000);
    p = floor(p/1000);
    if r == 0 && p == 0
        if i == 1
            s = ['0' s];
        end;
        break;
    elseif p == 0
        if ~isempty(s); s = [',' s]; end;
        s = [sprintf('%d', r) s];
        break;
    else
        if ~isempty(s); s = [',' s]; end;
        s = [sprintf('%03d', r) s];
    end;
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
