% % Interactive reader from database

global DATA;

if ~exist('session', 'var')
    session.idexperiment = 3; % Summer 2008
    session.idjudge = [];
    session.iddomain = 2; % expected to be 'CBN'
    session.iddeact = 1; % expected to be 'Normal tendency'
    filename = '../mat/#a_dataset_from_the_cells_db_default.mat';
end;


flag_db = true;

try
    connect_to_cells();
catch ME
    clc;
    fprintf('Could not connect to database, will work in offline mode.\n');
	input('--- Pause ---');
    flag_db = false;
end;
% assure_connected();



flag_end = 0;
while true
    clc;
    fprintf('* DATA *\n');
    if ~isempty(DATA)
        DATA
    else
        disp('Variable ''DATA'' does not exist.');
    end;

    if flag_db
        fprintf('*** Communication with the cells mysql database: *\n');
        fprintf('* Current setup *\n');

        shit = {'experiment', 'domain', 'deact', 'judge'};
        shit_names = {'Experiment', 'Domain', 'Activation scheme', 'Classifier list'};
        for i_shit = 1:length(shit)
            fprintf(['|| ' shit_names{i_shit} '||']);
            shit_list = session.(['id' shit{i_shit}]);

            if ~isempty(length(shit_list))

                for i_subshit = 1:length(shit_list)
                    if i_subshit == 1
                        wheres = ' where';
                    else
                        wheres = [wheres ' or'];
                    end;
                    wheres = [wheres ' id = ' mat2str(shit_list(i_subshit))];
                end;

                mym(['select id, name from ' shit{i_shit} wheres]);
            else
                fprintf('__None__.\n');
            end;
        end;
    end;
    
    fprintf(['|| file name: ' filename '\n']);


    option0 = menu('MAIN MENU', ...
        {'Change experiment', ...
         'Change domain', ...
         'Change activation scheme', ...
         'Change classifier list', ...
         'db --> DATA' ...
         'Go to Save menu ...' ...
        }, ...
        'Quit application');
    
    switch option0
        case 0
            break;
        case {1, 2, 3, 4}
            if flag_db
                clc;
%             fprintf('%d - %s\n', mym('select id, name, wncount from experiment order by id')); % order by id will show most recent last

                [ids, names] = mym(['select id, name from ' shit{option0} ' order by id']); % order by id will show most recent last

                no_shit = size(ids, 1);
                if no_shit == 0
                    disp([shit_names{option0} 'not encountered']);
                else
                    options = cell(1, no_shit);
                    for i_shit = 1:no_shit
                        options{i_shit} = [mat2str(ids(i_shit)) ':' names{i_shit}];
                    end;

                    option1 = menu(['SELECT ' shit_names{option0}], options, '(*Back*)');

                    if option1 > 0

                        id_shit = ids(option1);
                        session.(['id' shit{option0}]) = id_shit; % Alright!!!!!!!! Control!

    %                 if option == 0
    %                     IDEXPERIMENT = -1;
    %                     EXPERIMENT_NAME = ''
    %                     NO_WAVENUMBERS = 0
    %                 else
    %                     IDEXPERIMENT = ids(option);
    %                     EXPERIMENT_NAME = names{option}
    %                     NO_WAVENUMBERS = wncount_s(option);
    %                 end
                    end;
                end
            else
                fprintf('no\n');
            end;
            
%             break;
        case 5

            if flag_db
            
                data = data_new_from_database(session);
                DATA = data;
                input('--- Pause ---');

            else
                fprintf('no\n');
            end;


        case 6
            if isempty(DATA)
                disp('Variable DATA does not exist!');
                input('--- Pause ---');
            else
                while true
                    clc;
                    fprintf('* Save file: *\n');

                    fprintf(['|| file name: ' filename '\n']);


                    option2 = menu('SAVE FILE MENU', ...
                        {'Type another file name', ...
                         'Ask for a suggestion', ...
                         'DATA --> .mat' ...
                         'DATA --> .csv' ...
                        }, ...
                        'Back');

                    switch option2
                        case 0
                            break;
                        case 1
                            filenam = [input('% ', 's')];
                            if ~isempty(filenam)
                                filename = filenam;
                            end;
                        case 2
                            c = mym(sprintf('select name from experiment where id = %d', session.idexperiment));
                            prefix = good_file_name(c{1});
                            

                            
                            % Suggestion is a file inside the ../mat directory
    %                         filename = ['../mat/' str2filename('suggestion.mat')];
                            existing = dir('../mat');
                            for iex = 1:length(existing); existing(iex).name = ['../mat/' existing(iex).name]; end;

                            i_try = 1;
                            flag_ok = 0;
                            while i_try <= 9999
                                filenam = ['../mat/' sprintf('%s_%04d', prefix, i_try) '.mat' ];
                                if sum(strcmp({existing.name}, filenam)) > 0
                                    i_try = i_try+1;
                                else
                                    flag_ok = 1;
                                    break;
                                end;
                            end;
                            if flag_ok
                                if sum(strcmp(upper(input(sprintf('Suggestion is ''%s''. Accept it [Y/n]? ', filenam), 's')), {'', 'Y'})) > 0
                                    filename = filenam;
                                end;
                            else
                                fprintf('Gave up! Tried %d times.\n', i_try-1);
                            end;

                        case 3
                            disp(sprintf('Saving DATA in .mat format to file "%s"...', filename));
                            save(filename, 'DATA');
                        case 4
                            disp(sprintf('Saving DATA in .csv format to file "%s"...', filename));
%                             [rows, cols] = size(DATA.X);
                            dlmwrite(filename, [DATA.X DATA.classes], sprintf('\t'));
                            
%                             
%                             
%                             ones(1, rows), ones(1, cols+1));
%                             
%                             s = csv_from_cell(c);
%                             try
%                                 fid = fopen(filename, 'w');
%                                 fwrite(fid, s);
%                                 fclose(fid);
%                             catch ME
%                                 disp('Error writing file!');
%                                 input('--- Pause ---');
%                             end;
                    end;
                end;
            end;
            
        
    end;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
