function select_experiment()
global IDEXPERIMENT EXPERIMENT_NAME NO_WAVENUMBERS

assure_connected()

[ids, names, wncount_s] = mym('select id, name, wncount from experiment order by id'); % order by id will show most recent last

no_experiments = size(ids, 1);
if no_experiments == 0
    disp 'There are no experiments!'
else
    disp('Please select an experiment:')
    disp('  0 - (*Select None*)')
    for i = 1:no_experiments
        disp(sprintf('%3d - %s', i, names{i}))
    end
    
    while 1
        option = input('>>> ');
        if option < 0 || option > no_experiments
            disp('Invalid option!, try again.')
        else
            break
        end
    end
    
    if option == 0
        IDEXPERIMENT = -1;
        EXPERIMENT_NAME = ''
        NO_WAVENUMBERS = 0
    else
        IDEXPERIMENT = ids(option);
        EXPERIMENT_NAME = names{option}
        NO_WAVENUMBERS = wncount_s(option);
    end
end
        

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
