% function s = csv_from_cell(results_table)
function s = csv_from_cell(results_table)
chars_elim = '[]''';
lce = length(chars_elim);
disp('INFO: CSV delimiter is a TAB character.');

%disp('checkpoint sadsad1239u13');

% Converts all elements to str
[rows, cols] = size(results_table);
ii = 0;
for i = 1:rows
    for j = 1:cols
        t = results_table{i, j};
        
        % Eliminates undesired characters
        if ~isnumeric(t)
            stemp = t;
        else
            stemp = mat2str(t);
        end;
        for k = 1:lce
            stemp(logical(stemp == chars_elim(k))) = []; 
%             s_comp = ones(1, len_stemp)*chars_elim(k);
%             map = s == s_comp;
%             for i = len_stemp:-1:1
%                 if map(i)
%                     stemp(i) = [];
%                 end;
%             end;
        end;

        results_table{i, j} = stemp;
    end;

    ii = ii+1;
    if ii == 5
%        fprintf('%d rowsnow\n', i);
        ii = 0;
    end;
end;


% disp('checkpoint 1239u13');



% Calculates total stream size
len_total = 0;
for i = 1:rows
    for j = 1:cols
        len_total = len_total+length(results_table{i, j});
    end;
end;

len_total = len_total+(cols-1)*rows+rows; % first add for \t and second one for \n

% Allocates stream
s = char(' '*ones(1, len_total));

% Writes stream
iptr = 1;
ii = 0;
for i = 1:rows
    for j = 1:cols
        ilen = length(results_table{i, j});

        if j > 1
            s(iptr) = sprintf('\t');
            iptr = iptr+1;
        end;
        s(iptr:iptr+ilen-1) = results_table{i, j};
        iptr = iptr+ilen;
    end;
    
    if j > 1
        s(iptr) = sprintf('\n');
        iptr = iptr+1;
    end;
    
    ii = ii+1;
    if ii == 5
%        fprintf('%d rowsnow\n', i);
        ii = 0;
    end;
end;



% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
