% data_draw_loadings(data, class_origin=-1, flag_abs = 0, threshold = 1, flag_print_peaks = 0,
% flag_show_peaks = 0)
function data_draw_cv(data, class_origin, varargin)

if ~exist('class_origin', 'var')
    class_origin = -1;
end;

if strcmp(data.domain, 'original')
    error('Loadings do not exist in dataset original domain!');
end;
cv = data_get_cv(data, class_origin);

draw_loadings_complete(data, cv, data.class_labels, varargin{:});
title(sprintf('%s Cluster Vectors Plot', data_get_title(data)));

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
