function data = data_plot(data)


% htemp = plot(data.x, data.X');

pieces = data_split_classes(data);
h = [];
for i = 1:length(pieces)
    eh = zeros(1, size(pieces(i).X, 2));
    h_temp = plot(data.x, pieces(i).X', 'Color', find_color(i));
    h(end+1) = h_temp(1);
    hold on;
end;
legend(h, data.class_labels);

alpha(0);


if data.flag_wn
    format_wn(data);
end;

title('All data');
format_frank();




% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
