% function format_comma(ax)
%
% 
function format_comma(ax, flag_y)

if ~exist('ax')
    ax = gca();
end;

if ~exist('flag_y')
    flag_y = 0;
end;

a = {'XTick'};
if flag_y
    a{end+1} = 'YTick';
end;

for i = 1:length(a)
    numbers = get(ax, a{i});
    labels = cell(1, length(numbers));
    for j = 1:length(numbers)
        labels{j} = format_number_with_commas(numbers(j));
    end;
  set(ax, [a{i} 'Label'], labels);
end  
  

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
