% function name = good_file_name(name)
%
% Replaces invalid characters in name with an underscore ('_')
function name = good_file_name(name)
len = size(name, 2);
for i = 1:len
    ch = name(i);
    if sum(ch == [65:65+25 97:97+25 48:48+9]) == 0 && sum(ch == ['_-()[].']) == 0
        name(i) = '_';
    end;
end;


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
