% function model_new(name)
%
% Creates a new generic classifier. These function defines the basic variables for the 'model' structure
function m = model_new(name)

m.name = 'Unnamed';
if exist('name', 'var')
    m.name = name;
end;

m.time_train = 0;
m.time_estimate = 0;

m.important_prop_names = {};
m.important_prop_descriptions = {};

m.f_train = '';
m.f_test = '';
m.f_boot = '';

m.flag_class2mo = 0; % whether classes must be converter into multiple-output boolean targets.


m.no_features = 0;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
