%
% Inputs
%   params: cell array {'name1', value1, 'name2', value2 ...}
%
% Executes a.models{i}.name1 = value1 for i = 1 to length(a.models)
function a = modelset_setbatch(a, params)

for m = 1:length(a.models)
    for i = 1:length(params)/2
        varname = params{i*2-1};
        value = params{i*2};
        eval(sprintf('a.models{%d}.%s = value;', m, varname));
    end;
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
