% function x = round_random(x)
%
% This function rounds randomly either to the floor or ceiling in case an
% element of x is exactly zzz.5
%
% This functions works only with unidimensional vectors
%
% 20090501: I switched this to work exactly like round() so identical
% datasets will give identical results in the classification methods
% (whenever possible)
function x = round_random(x)

x = round(x);

return;

for i = 1:length(x)
    if x(i) ~= floor(x(i)) && x(i)-floor(x(i)) == ceil(x(i))-x(i)
        x(i) = round(floor(x(i))+rand());
    else
        x(i) = round(x(i));
    end;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
