% flag_selected = select_load_file()
% 
% Asks whether the user wants to load a .mat or a .txt file, and then calls
% whether select_load_mat_file() or select_load_txt_file()
% 
% Returns:
%   flag_selected: 0 - no file was selected; 1 - a file was selected
function flag_selected = select_load_file()
% global IDEXPERIMENT EXPERIMENT_NAME NO_WAVENUMBERS IDJUDGE_REF CLASS_LABELS DATA

while 1
    fprintf('Select data source?\n0 - *Cancel*\n1 - .mat file from ''../mat'' directory\n2 - .txt file from ''../txt'' directory\n');
    option = input('% ');
    if option >= 0 && option <= 2
        break;
    end;
    disp('Invalid option, please try again.');
end;

flag_selected = 0;
if option == 1
    flag_selected = select_load_mat_file();
elseif option == 2
    flag_selected = select_load_txt_file();
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
