function select_experiment()
global IDJUDGE_REF JUDGE_NAME CLASS_LABELS

assure_connected()

% selects all 
[ids, names, idscoregroup_s] = mym('select id, name, idscoregroup from judge where idscoregroup > 0 order by id'); 

no_judges = size(ids, 1);
if no_judges == 0
    disp 'There are no classifiers avaiable!'
else
    disp('Please select a classifier to be used as reference:')
    disp('  0 - (*Select None*)')
    for i = 1:no_judges
        disp(sprintf('%3d - %s', i, names{i}))
    end
    
    while 1
        option = input('>>> ');
        if option < 0 || option > no_judges
            disp('Invalid option!, try again.')
        else
            break
        end
    end
    
    if option == 0
        IDJUDGE_REF = -1;
        JUDGE_NAME = '';
        CLASS_LABELS = {};
    else
        IDJUDGE_REF = ids(option);
        JUDGE_NAME = names{option};
        CLASS_LABELS = mym(sprintf('select code from score where idscoregroup = %d order by id', idscoregroup_s(option)))'; % 1-by-... cell
    end
end
        

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
